addHook("MobjLineCollide", function(mo, line)
	if mo and mo.valid and line and line.valid and mo.player and mo.player.valid
		mo.player.clastlinehit = line
	end
end)

addHook("MobjMoveBlocked", function(mo)
	if mo and mo.valid
		if mo.type == MT_PLAYER and mo.player
			local player = mo.player
			if player.mo.skin ~= "speccy" then return end
			if (player.pflags & PF_JUMPED) or mo.startwall
			and not player.cantWall
				if player.clastlinehit
					mo.player.wallJumped = 0
					local angle = R_PointToAngle2(0, 0, mo.player.clastlinehit.dx, mo.player.clastlinehit.dy)
					mo.player.wallLastAng = angle
					if P_PointOnLineSide(mo.x, mo.y, mo.player.clastlinehit) == 0
						mo.player.wallAng = angle+ANGLE_90+ANGLE_180
					else
						mo.player.wallAng = angle-ANGLE_90+ANGLE_180
					end
					local side
					if P_PointOnLineSide(mo.x, mo.y, mo.player.clastlinehit) == 0
						side = mo.player.clastlinehit.frontside
					else
						side = mo.player.clastlinehit.backside
					end
					local invside
					if side == mo.player.clastlinehit.frontside
						invside = mo.player.clastlinehit.backside
					else
						invside = mo.player.clastlinehit.frontside
					end	
					//Wall check	
						if (player.clastlinehit.flags & ML_NOCLIMB)
							player.cantClimb = true
						end
						if side
							/*local texture = side.rowoffset
							if side.rowoffset < texture
								player.texdown = 5
								print("down")
							elseif 	side.rowoffset > texture
								player.texup = 5
								print("up")
							end*/
							if invside
								local invsec = invside.sector
								if invsec
									local invsecpic = invsec.ceilingpic
									if P_MobjFlip(mo) == 1
										invsecpic = invside.sector.ceilingpic
									else
										invsecpic = invside.sector.floorpic
									end
									if invsec and (invsecpic == "F_SKY1")
										if P_MobjFlip(mo) == 1
											if mo.z+mo.height > invsec.ceilingheight
												mo.player.cantClimb = true
											end
										else
											if mo.z > invsec.ceilingheight
												mo.player.cantClimb = true
											end
										end
									end
								end	
							end	
							if not side.toptexture
							and not side.bottomtexture
							and not side.midtexture
								if not invside
								or (invside 
								and not invside.bottomtexture
								and not invside.toptexture
								and not invside.midtexture)
									mo.player.cantClimb = true
								end
							end
						end	
					local line = player.clastlinehit
					local invsec = line.backsector
					if P_PointOnLineSide(mo.x, mo.y, line) == 0
						invsec = line.backsector
					else
						invsec = line.frontsector
					end
					if invsec
						for rover in invsec.ffloors()
							if (rover.flags & FF_EXISTS or rover.flags & FF_BLOCKPLAYER)
								if ((mo.z > rover.bottomheight)
								or ((mo.z+mo.height) < rover.topheight))
									mo.player.cantClimb = false
									//print("how to fix")
								end
							else
								mo.player.cantClimb = true
							end
						end
					end	
					if P_IsObjectOnGround(mo) then
						mo.holdtimer = 0
						player.wallCling = 0
						player.cantClimb = true
						player.cantWall = 1
						
					end
					//Wall Check end
					if not player.cantClimb
					and not P_IsObjectOnGround(mo)
					and ((not player.powers[pw_carry] == CR_PLAYER)
					or (not player.powers[pw_carry]))
					and not player.glidetime
					and not player.climbing
						if (mo.momz*P_MobjFlip(mo) <= 0)
							mo.startwall = true
						end
						if mo.startwall
							mo.momx = 0
							mo.momy = 0
							if not player.wallCling
								S_StartSound(mo, sfx_kc50)
							end
							player.wallCling = 5
							mo.state = S_PLAY_PAIN
							player.drawangle = player.wallAng+ANGLE_180
							player.pflags = $|PF_STASIS|PF_NOJUMPDAMAGE
							if player.wallAng
								P_Thrust(mo, player.wallAng+ANGLE_180, 2*FRACUNIT)
							end
						end	
					end
					if not player.cantClimb
						player.nearWall = 5
					end
				end	
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.powers[pw_carry] != CR_NIGHTSMODE
		if player.mo.skin ~= "speccy" then return end
		player.nearWall = $ or 0
		if player.nearWall
			player.nearWall = $ - 1
		else
			player.mo.startwall = false
		end
		if player.wasclinged and not player.wallCling then
			if player.mo.state ~= S_PLAY_SPRING then
				player.mo.state = S_PLAY_FALL
			end
			player.wasclinged = false
			player.cantClimb = false
			player.mo.holdtimer = 0
		end
		if player.wallCling and not P_IsObjectOnGround(player.mo) //This thing. the actual wall jump
			player.wallCling = $ - 1
			player.wasclinged = true
			P_Thrust(player.mo, player.wallAng+ANGLE_180, 2*FRACUNIT)
			local mo = player.mo
			if mo.holdtimer > TICRATE then
				if mo.momz*P_MobjFlip(mo) <= -2*FRACUNIT
					if player.powers[pw_underwater] then
						P_SetObjectMomZ(mo, -FRACUNIT/(10*TICRATE), true)
					else
						P_SetObjectMomZ(mo, -FRACUNIT/(5*TICRATE), true)
					end
					P_SpawnSkidDust(player, mo.radius/2, true)
				end
			elseif mo.momz*P_MobjFlip(mo) <= 0 then
				P_SetObjectMomZ(mo, 0, false)
			end
			mo.holdtimer = $ + 1
			if player.speccyjumptap then
				if not player.wall
				or (player.wall and player.wall <= 5)
				and player.wallAng
				and not player.cantClimb
				and not player.cantWall
				and not G_EnoughPlayersFinished()
					player.cantWall = 5
					player.mo.startwall = false
					player.drawangle = player.wallAng
					local elmz = (player.mo.momz*P_MobjFlip(player.mo))
					local mzdown = 0
					local slowmomz = 1
					if elmz > 0
						mzdown = 0
					else
						mzdown = abs(elmz)
					end
					if elmz <= FRACUNIT
						slowmomz = 1
					else
						slowmomz = elmz/FRACUNIT
					end
					local nine = 11
					local ten = 10
					if slowmomz > nine + ten //U Stupid, Whats 9+10
						slowmomz = 21 //21?
					end
					if slowmomz < 1
						slowmomz = 1
					end
					P_InstaThrust(player.mo, player.wallAng, 8*FRACUNIT)
					player.mo.state = S_PLAY_SPRING
					if player.powers[pw_underwater] then
						P_SetObjectMomZ(player.mo, 6*player.jumpfactor, false)
					else
						P_SetObjectMomZ(player.mo, 12*player.jumpfactor, false)
					end
					S_StartSound(player.mo, sfx_cdfm02)
					player.pflags = $|PF_JUMPED & ~PF_NOJUMPDAMAGE
					player.mo.holdtimer = 0
					player.wallCling = 0
				end
			end
		else
			if player.cantClimb
				player.cantClimb = false
			end
		end
		if player.cantWall
			player.cantWall = $ - 1
		end
		if P_IsObjectOnGround(player.mo)
			player.cantClimb = false
			player.mo.holdtimer = 0
		end
		player.wall = $ or 0
		if player.cmd.buttons & BT_JUMP
			player.wall = $ + 1
		else
			player.wall = 0
		end
		player.clastlinehit = nil
	end
end)