-- Speccy's abilities.

freeslot(
	"S_NSPECCY_DIVE",
	"S_NSPECCY_SLIDE",
	"S_NSPECCY_CRAWL",
	"SPR2_LOIS",
	"S_NLOIS",
	"S_NSPECCY_SITDOWN",
	"S_NSPECCY_SIT",
	"S_NSPECCY_SIT_TIRED",
	"S_NSPECCY_TWIRL",
	"S_NSPECCY_SWIM_IDLE",
	"S_NSPECCY_SWIM"
)

states[S_NSPECCY_DIVE] = {
	sprite = SPR_PLAY,
	frame = SPR2_FLY_|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_SLIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_SPIN|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_CRAWL] = {
	sprite = SPR_PLAY,
	frame = SPR2_GLID|FF_ANIMATE,
	tics = -1,
	var1 = 3,
	var2 = 7,
	nextstate = S_NULL
}

states[S_NSPECCY_SWIM_IDLE] = {
	sprite = SPR_PLAY,
	frame = SPR2_CLNG|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_NSPECCY_SWIM] = {
	sprite = SPR_PLAY,
	frame = SPR2_SWIM|FF_ANIMATE,
	tics = 12,
	var1 = 2,
	var2 = 4,
	nextstate = S_NSPECCY_SWIM_IDLE
}

states[S_NSPECCY_SITDOWN] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEE|FF_ANIMATE|A,
	tics = 20,
	var1 = 3,
	var2 = 5,
	nextstate = S_NSPECCY_SIT
}

states[S_NSPECCY_SIT] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEL|A,
	tics = 105,
	nextstate = S_NSPECCY_SIT_TIRED
}

states[S_NSPECCY_SIT_TIRED] = {
	sprite = SPR_PLAY,
	frame = SPR2_BNCE|FF_ANIMATE|A,
	tics = -1,
	var1 = 1,
	var2 = 17,
	nextstate = S_NULL
}

states[S_NSPECCY_TWIRL] = {
	sprite = SPR_PLAY,
	frame = SPR2_DASH|FF_ANIMATE,
	tics = 8,
	var1 = 3,
	var2 = 2,
	nextstate = S_PLAY_FALL
}


states[S_NLOIS] = {
	sprite = SPR_PLAY,
	frame = SPR2_LOIS|A,
	tics = -1,
	nextstate = S_NULL
}

local speccycbutton = BT_CUSTOM3
local speccydbutton = BT_USE

local buttons = {BT_USE, BT_CUSTOM1, BT_CUSTOM2, BT_CUSTOM3}

COM_AddCommand("speccy_remap", function(p, arg, arg2)
	if arg == nil or (arg ~= "dive" and arg ~= "crouch") then
		CONS_Printf(p, "speccy_remap:\n - Usage: speccy_remap <move> <button>\n\nMoves:\n - dive: Dive/Roll\n - crouch: Crouch\n\nButtons:\n - 1: Spin\n - 2: Custom 1\n - 3: Custom 2\n - 4: Custom 3")
	else
		if tonumber(arg2) ~= nil then
			arg2 = tonumber(arg2)
			if arg == "dive" then
				speccydbutton = buttons[arg2]
			elseif arg == "crouch" then
				speccycbutton = buttons[arg2]
			end
		else
			CONS_Printf(p, "speccy_remap:\n - Usage: speccy_remap <move> <button>\n\nMoves:\n - dive: Dive/Roll\n - crouch: Crouch\n\nButtons:\n - 1: Spin\n - 2: Custom 1\n - 3: Custom 2\n - 4: Custom 3")
		end
	end
end)

addHook("PlayerSpawn", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	p.speccysitdowntimer = 0
	p.speccytwirlcooldown = 0
end)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccydeathtimer == nil then 
		p.speccydive = false
		p.speccycrouch = false
		p.speccyroll = false
		p.speccylois = false
		p.speccydiveangle = p.drawangle
		p.speccyjumptimer = 0
		p.speccydeathtimer = 0 
		p.speccysitdowntimer = 0
		p.mo.holdtimer = 0
		p.speccytwirlcooldown = 0
		p.mo.playerdied = false
	end
end)

local function speccyCanCrouch(p)
	if not(p.mo and p.mo.valid) then return false end
	if p.mo.skin ~= "speccy" then return false end
	if p.mo.health < 1 then return end
	if not(p.cmd.buttons & speccycbutton) then return false end
	if not P_IsObjectOnGround(p.mo) then return false end
	if P_PlayerInPain(p) then return false end
	if p.speccyroll then return false end
	if p.fluffymoonwalking then return false end
	if p.speccydive then return false end
	return true
end

local function CrouchHeight(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccycrouch or p.speccydiving or (p.pflags & PF_SPINNING) then
		return skins[p.mo.skin].height/2
	else
		return skins[p.mo.skin].height
	end
end

local function CrouchGap(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccycrouch then
		return true
	end
end

addHook("PlayerHeight", CrouchHeight)
addHook("PlayerCanEnterSpinGaps", CrouchGap)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.health < 1 then return end
	if p.mo.skin ~= "speccy" then return end
	
	if not (p.cmd.buttons & speccydbutton) then
		p.speccyspinready = true
		p.speccyspintap = false
	elseif p.speccyspinready then
		p.speccyspinready = false
		p.speccyspintap = true
	else
		p.speccyspintap = false
	end
	
	if not (p.cmd.buttons & BT_TOSSFLAG) then
		p.speccyloisready = true
		p.speccyloistap = false
	elseif p.speccyloisready then
		p.speccyloisready = false
		p.speccyloistap = true
	else
		p.speccyloistap = false
	end
	
	if (not (p.cmd.buttons & BT_JUMP)) and (not P_IsObjectOnGround(p.mo)) then
		p.speccyjumpready = true
		p.speccyjumptap = false
	elseif p.speccyjumpready then
		p.speccyjumpready = false
		p.speccyjumptap = true
	else
		p.speccyjumptap = false
	end
	
	if p.speccyloistap then
		if P_RandomRange(1,64) == 1 then
			p.speccylois = true
		end
	end
	
	if p.mo.state == S_PLAY_WAIT then
		if p.speccysitdowntimer >= 10*TICRATE then
			p.mo.state = S_NSPECCY_SITDOWN
		end
		p.speccysitdowntimer = $ + 1 
	else
		p.speccysitdowntimer = 0
	end
	
	if p.mo.state == S_NSPECCY_SITDOWN then
		p.pflags = $|PF_STASIS
	elseif p.mo.state == S_NSPECCY_SIT or p.mo.state == S_NSPECCY_SIT_TIRED then
		p.pflags = $ & ~PF_STASIS
		if p.speed ~= 0 then
			p.mo.state = S_PLAY_STND
		end
	end
	
	if speccyCanCrouch(p) then
		p.speccycrouch = true
		p.pflags = $|PF_JUMPSTASIS
		p.normalspeed = 4*FRACUNIT
		if (p.speed-abs(p.mo.momz)) > 0 then
			if p.mo.state ~= S_NSPECCY_CRAWL then
				p.mo.state = S_NSPECCY_CRAWL
			end
			p.speccyjumptimer = 0
		else
			p.mo.state = S_PLAY_GLIDE_LANDING 
			if P_IsObjectOnGround(p.mo) then
				p.speccyjumptimer = $ + 1
			else
				p.speccyjumptimer = 0
			end
			if p.speccyjumptimer == 52 then 
				S_StartSound(p.mo, sfx_s3ka2, p)
			end
			
			if p.speccyjumptimer >= 52 then 
				if leveltime % 8 == 0 then
					p.mo.colorized = true
				else
					p.mo.colorized = false
				end
			else
				p.mo.colorized = false
			end
		end
		if p.speccyspintap then
			p.pflags = $|PF_SPINNING
			p.pflags = $ & ~PF_JUMPSTASIS
			if p.speed < skins[p.mo.skin].maxdash-skins[p.mo.skin].mindash*2 then
				P_Thrust(p.mo, p.drawangle, skins[p.mo.skin].maxdash-skins[p.mo.skin].mindash*3)
			else
				p.speed = skins[p.mo.skin].maxdash-skins[p.mo.skin].mindash*2
			end
			S_StartSound(p.mo, sfx_shrpgo, p)
			p.normalspeed = skins[p.mo.skin].normalspeed
			p.mo.state = S_PLAY_ROLL
			p.speccyroll = true
			p.speccycrouch = false
			p.mo.colorized = false
			p.speccyjumptimer = 0
			return
		end
		if p.cmd.buttons & BT_JUMP then
			if p.speccyjumptimer >= 52 then
				p.speccycrouch = false
				p.pflags = $|PF_JUMPED & ~PF_JUMPSTASIS
				if p.powers[pw_underwater] then
				P_SetObjectMomZ(p.mo, 9*p.jumpfactor, false)
			else
				P_SetObjectMomZ(p.mo, 18*p.jumpfactor, false)
			end
				S_StartSound(p.mo, sfx_cdfm02, p)
				p.normalspeed = skins[p.mo.skin].normalspeed
				p.mo.state = S_PLAY_ROLL
				p.mo.colorized = false
				p.speccyjumptimer = 0
			end
		end
	else
		if p.speccycrouch then
			p.mo.state = S_PLAY_STND
			p.normalspeed = skins[p.mo.skin].normalspeed
			p.pflags = $ & ~PF_JUMPSTASIS
			p.mo.colorized = false
			p.speccyjumptimer = 0
		end
		p.speccycrouch = false
	end
	
	if p.speccyroll then
		if (p.pflags & PF_JUMPED) or ((p.mo.eflags & MFE_SPRUNG) and p.mo.momz ~= 0) or p.powers[pw_carry] or p.speed < FRACUNIT or P_PlayerInPain(p) then
			p.speccyroll = false
			p.pflags = $ & ~PF_SPINNING
			if P_IsObjectOnGround(p.mo) then
				p.mo.state = S_PLAY_WALK
			end
			return
		end
		p.pflags = $|PF_SPINNING
		p.mo.state = S_PLAY_ROLL
		if p.speccyspintap and P_IsObjectOnGround(p.mo) then
			P_Thrust(p.mo, p.drawangle, skins[p.mo.skin].maxdash-skins[p.mo.skin].mindash*4-skins[p.mo.skin].mindash/3-skins[p.mo.skin].mindash/3)
			if p.powers[pw_underwater] then
				P_SetObjectMomZ(p.mo, 2*p.jumpfactor, false)
			else
				P_SetObjectMomZ(p.mo, 4*p.jumpfactor, false)
			end
		end
	end
	
	if p.speccydive then
		if (p.pflags & PF_JUMPED) or (p.mo.eflags & MFE_SPRUNG) or p.powers[pw_carry] or p.speed < FRACUNIT or P_PlayerInPain(p) then
			p.speccydive = false
			p.pflags = $ & ~PF_SPINNING
			if P_IsObjectOnGround(p.mo) then
				p.mo.state = S_PLAY_WALK
			end
			return
		end
		p.pflags = $|PF_SPINNING
		if P_IsObjectOnGround(p.mo) then
			p.mo.state = S_NSPECCY_SLIDE
			P_SpawnSkidDust(p, p.mo.radius/2, true)
			P_Thrust(p.mo, p.drawangle, -FRACUNIT/8)
		else
			p.mo.state = S_NSPECCY_DIVE
		end
	end
	
	if (p.mo.state == S_NSPECCY_SWIM or p.mo.state == S_NSPECCY_SWIM_IDLE) and not p.powers[pw_underwater] then
		p.mo.state = S_PLAY_SPRING
		p.pflags = $|PF_JUMPED
		P_SetObjectMomZ(p.mo, 10*p.jumpfactor, false)
	elseif p.mo.state == S_NSPECCY_SWIM_IDLE and P_IsObjectOnGround(p.mo) then
		p.mo.state = S_PLAY_STND 
	elseif p.powers[pw_underwater] and not (p.speccycrouch or p.speccycrawl or p.speccyroll or p.speccydive or p.fluffymoonwalking) then
		p.pflags = $ & ~PF_JUMPED
		if p.mo.state ~= S_NSPECCY_SWIM_IDLE and p.mo.state ~= S_NSPECCY_SWIM and (p.mo.state ~= S_PLAY_STND and not P_IsObjectOnGround(p.mo)) then
			p.mo.state = S_NSPECCY_SWIM_IDLE
		end
	end
	
	if p.speccytwirlcooldown then
		p.speccytwirlcooldown = $ - 1
	end
	
	if p.speccylois then
		p.mo.state = S_NLOIS
	end
end)

addHook("JumpSpecial", function(p)
	if p.mo.health < 1 then return end
	if p.mo.skin ~= "speccy" then return end
	if p.speccydive and P_IsObjectOnGround(p.mo) then
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 3*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 6*p.jumpfactor, false)
		end
		S_StartSound(p.mo, sfx_jump, p)
		p.mo.state = S_PLAY_ROLL
		p.speccydive = false
		p.pflags = $|PF_JUMPED
		p.pflags = $ & ~PF_SPINNING
		return true
	elseif (p.pflags & PF_JUMPED) and p.speccyjumptap and (not p.speccytwirlcooldown) and (not p.powers[pw_underwater]) and not (p.speccycrouch or p.speccycrawl or p.speccyroll or p.speccydive or p.fluffymoonwalking) then
		if P_MobjFlip(p.mo) then
			if p.mo.momz < 1*FRACUNIT+FRACUNIT/2 then
				P_SetObjectMomZ(p.mo, p.jumpfactor*5/2, false)
			end
		else
			if p.mo.momz > 1*FRACUNIT+FRACUNIT/2 then
				P_SetObjectMomZ(p.mo, p.jumpfactor*5/2, false)
			end
		end
		p.mo.state = S_NSPECCY_TWIRL
		p.speccytwirlcooldown = 17
	elseif (p.speccyjumptap) and p.powers[pw_underwater] and (not (p.pflags & PF_SLIDING)) and not (p.speccycrouch or p.speccycrawl or p.speccyroll or p.speccydive or p.fluffymoonwalking) then
		p.mo.state = S_NSPECCY_SWIM
		if P_MobjFlip(p.mo) then
			if p.mo.momz > 6*FRACUNIT then
				P_SetObjectMomZ(p.mo, p.jumpfactor*5/2, true)
			else
				P_SetObjectMomZ(p.mo, p.jumpfactor*10/2, true)
			end
		else
			if p.mo.momz < 6*FRACUNIT then
				P_SetObjectMomZ(p.mo, p.jumpfactor*5/2, true)
			else
				P_SetObjectMomZ(p.mo, p.jumpfactor*10/2, true)
			end
		end
		return true
	end
end)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.mo.health < 1 then return end
	if not p.speccyspintap then return end
	if P_PlayerInPain(p) then return false end
	if p.speccycrouch or p.speccycrawl or p.speccyroll or p.fluffymoonwalking then return end
	if p.powers[pw_super] == 1 or p.mo.state == S_PLAY_SUPER_TRANS1|S_PLAY_SUPER_TRANS2|S_PLAY_SUPER_TRANS3|S_PLAY_SUPER_TRANS4|S_PLAY_SUPER_TRANS5|S_PLAY_SUPER_TRANS6 then return end
	if p.speed < 8*FRACUNIT then return end
	if p.speccydive then
		if not P_IsObjectOnGround(p.mo) then return end
		P_Thrust(p.mo, p.speccydiveangle, FRACUNIT/17)
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 2*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 5*p.jumpfactor, false)
		end
		p.speccydiveangle = p.drawangle
	else
		if p.powers[pw_underwater] then
			P_SetObjectMomZ(p.mo, 3*p.jumpfactor, false)
		else
			P_SetObjectMomZ(p.mo, 6*p.jumpfactor, false)
		end
		p.speccydiveangle = p.drawangle
		p.mo.state = S_NSPECCY_DIVE
		p.pflags = $ & ~PF_JUMPED
		p.pflags = $|PF_SPINNING
		P_InstaThrust(p.mo, p.speccydiveangle, p.speed)
		p.speccydive = true
		S_StartSound(p.mo, sfx_mario6)
	end
end)

/*
 
-- Wall jump? Wall jump.

addHook("MobjMoveBlocked", function(pmo, mo, line)
	if not(pmo and pmo.valid) then return end
	if pmo.skin ~= "speccy" then return end
	if P_IsObjectOnGround(pmo) then return end
	if line and ((pmo.player.pflags & PF_JUMPED) or pmo.player.speccysliding) then
		local angle = R_PointToAngle2(0, 0, line.dx, line.dy)
		pmo.player.cantslide = false
		local sec
		if line.flags & ML_NOCLIMB then return end
		if P_PointOnLineSide(pmo.x, pmo.y, line) == 0
			sec = line.backsector
			pmo.player.wallang = angle+ANGLE_90
		else
			sec = line.frontsector
			pmo.player.wallang = angle-ANGLE_90
		end
		if sec == nil then return end
		if pmo.z+(pmo.height/2) > sec.ceilingheight and sec.ceilingpic == "F_SKY1" then
			pmo.player.cantslide = true
		end
		if (not pmo.player.cantslide) and (pmo.momz < 1) then
			pmo.player.pflags = $|PF_STASIS
			pmo.player.speccysliding = true
		else
			pmo.player.speccysliding = false
			pmo.player.pflags = $ & ~PF_STASIS
			pmo.holdtimer = 0
		end
	end
end, MT_PLAYER)

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	local pmo = p.mo
	if P_IsObjectOnGround(pmo) then pmo.player.speccysliding = false pmo.holdtimer = 0 return end
	if not pmo.player.speccysliding then return end
	pmo.player.drawangle = pmo.player.wallang
	pmo.momx = 0
	pmo.momy = 0
	pmo.state = S_PLAY_PAIN
	pmo.player.pflags = $ & ~PF_JUMPED
	if pmo.holdtimer > TICRATE then
		if pmo.momz*P_MobjFlip(pmo) <= -2*FRACUNIT
			if pmo.player.powers[pw_underwater] then
				P_SetObjectMomZ(pmo, -FRACUNIT/(10*TICRATE), true)
			else
				P_SetObjectMomZ(pmo, -FRACUNIT/(5*TICRATE), true)
			end
			P_SpawnSkidDust(p, p.mo.radius/2, true)
		end
	elseif pmo.momz*P_MobjFlip(pmo) < 0 then
		P_SetObjectMomZ(pmo, 0, false)
	end
	pmo.holdtimer = $ + 1
	if pmo.player.speccyjumptap then
		P_InstaThrust(pmo, pmo.player.wallang+ANGLE_180, 8*FRACUNIT)
		pmo.state = S_PLAY_SPRING
		pmo.player.drawangle = pmo.player.wallang+ANGLE_180
		if pmo.player.powers[pw_underwater] then
			P_SetObjectMomZ(pmo, 6*pmo.player.jumpfactor, false)
		else
			P_SetObjectMomZ(pmo, 12*pmo.player.jumpfactor, false)
		end
		S_StartSound(p.mo, sfx_cdfm02, p)
		pmo.player.pflags = $|PF_JUMPED
		pmo.player.speccysliding = false
		pmo.holdtimer = 0
	end
end)

*/