addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.mo.health > 0 then return end
	if p.mo.disappear then
		p.mo.state = S_INVISIBLE
		P_SetObjectMomZ(p.mo, FRACUNIT/2+FRACUNIT/8, false)
	elseif p.mo.falltodeath then
		P_SetObjectMomZ(p.mo, -FRACUNIT*p.speccydeathtimer, false)
		p.speccydeathtimer = $ + 1
		p.mo.rollangle = $+ANG15
		if p.fakedrawangle == nil then
			p.fakedrawangle = p.drawangle
		end
		p.fakedrawangle = $+ANG15
		p.drawangle = p.fakedrawangle
		p.mo.state = S_PLAY_DEAD
	elseif p.mo.quiteshockinghonestly then
		p.mo.state = S_PLAY_EDGE
		P_SetObjectMomZ(p.mo, FRACUNIT/2+FRACUNIT/8, false)
		p.mo.momx = 0
		p.mo.momy = 0
		p.mo.colorized = true
		if p.speccydeathtimer % 4 == 0 then
			local num = P_RandomRange(1,3)
			if num == 1 then
				p.mo.color = SKINCOLOR_WHITE
			elseif num == 2 then
				p.mo.color = SKINCOLOR_BLACK
			else
				p.mo.color = SKINCOLOR_BLUE
			end
		end
		p.speccydeathtimer = $ + 1
	elseif p.mo.crushedyourheart then
		P_SetObjectMomZ(p.mo, FRACUNIT/2+FRACUNIT/8, false)
		p.mo.state = S_PLAY_DEAD
	elseif p.mo.anxietyapproachedyou then
		P_SetObjectMomZ(p.mo, FRACUNIT, false)
		p.mo.rollangle = $+ANG1*4
		if p.fakedrawangle == nil then
			p.fakedrawangle = p.drawangle
		end
		p.fakedrawangle = $+ANG1*5
		p.drawangle = p.fakedrawangle
		if p.speccydeathtimer < 2*TICRATE+17 then
			p.playerstate = PST_LIVE
		elseif p.lives > 0 then
			p.playerstate = PST_REBORN
		else
			p.playerstate = PST_DEAD
		end
		p.speccydeathtimer = $ + 1
		p.mo.state = S_PLAY_DRWN
	elseif p.mo.thumbtacked then
		if p.speccydeathtimer < 1 then
			P_SetObjectMomZ(p.mo, 12*FRACUNIT, false)
			P_Thrust(p.mo, p.drawangle+ANGLE_180+FixedAngle(P_RandomRange(-45, 45)*FRACUNIT), 12*FRACUNIT)
			p.speccydeathtimer = 1
		else
			if not P_IsObjectOnGround(p.mo) then
				p.mo.rollangle = $ + ANG15
			else
				p.mo.state = S_NSPECCY_SLIDE
				p.mo.rollangle = 0
				p.mo.momx = 0
				p.mo.momy = 0
				P_SetObjectMomZ(p.mo, FRACUNIT/2+FRACUNIT/8, false)
			end
		end
	else
		p.playerstate = PST_LIVE
		p.mo.momx = 0
		p.mo.momy = 0
		if p.speccydeathtimer < TICRATE
			P_SetObjectMomZ(p.mo, FRACUNIT/2+FRACUNIT/8, false)
		elseif p.speccydeathtimer == TICRATE then
			P_SetObjectMomZ(p.mo, 12*FRACUNIT, false)
		elseif p.speccydeathtimer < 2*TICRATE+17 then
			p.mo.rollangle = $ + ANG15
		elseif p.lives > 0 then
			p.playerstate = PST_REBORN
		else
			p.playerstate = PST_DEAD
		end
		p.mo.state = S_PLAY_DEAD
		p.speccydeathtimer = $ + 1
	end
end)

addHook("MobjDeath", function(s, inf, src, dmgtype)
	if not(s and s.valid) then return end
	if s.skin ~= "speccy" then return end
	s.player.speccydive = false
	s.player.speccycrouch = false
	s.player.speccyroll = false
	s.player.speccylois = false
	s.player.fluffymoonwalking = false
	s.player.wallCling = 0
	s.player.cantClimb = true
	s.player.speccydeathtimer = 0
	s.player.speccytwirlcooldown = 0
	if dmgtype == DMG_NUKE then
		s.disappear = true
	elseif dmgtype == DMG_DEATHPIT then
		s.player.speccydeathtimer = 5
		s.falltodeath = true
	elseif dmgtype == DMG_ELECTRIC then
		s.quiteshockinghonestly = true
	elseif dmgtype == (DMG_DROWNED or DMG_SPACEDROWN) or (s.player.powers[pw_underwater] and dmgtype ~= DMG_CRUSHED and dmgtype ~= DMG_DEATHPIT) then
		s.anxietyapproachedyou = true
	elseif dmgtype == DMG_CRUSHED then
		s.crushedyourheart = true
		s.spriteyscale = FRACUNIT/8
	elseif dmgtype == DMG_SPIKE then
		s.thumbtacked = true
	end
end, MT_PLAYER)