freeslot(
"S_NSPECCY_MOONSTAND",
"S_NSPECCY_MOONWALKER"
)

states[S_NSPECCY_MOONSTAND] = {

	sprite = SPR_PLAY,
	frame = SPR2_CLMB|A,
	tics = -1,
	nextstate = S_NULL

}

states[S_NSPECCY_MOONWALKER] = {

	sprite = SPR_PLAY,
	frame = SPR2_TWIN|FF_ANIMATE,
	tics = -1,
	var1 = 7,
	var2 = 4,
	nextstate = S_NULL

}

COM_AddCommand("fluffymoonwalking", function(p, arg)
	if not (p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.mo.health < 1 then return end
	if not P_IsObjectOnGround(p.mo) then return end
	if tonumber(arg) ~= nil then
		if tonumber(arg) > 0 and tonumber(arg) < 7 then
			S_ChangeMusic("MNWKS"+arg, true, p)
			p.fluffymoonwalking = true
			p.mo.state = S_NSPECCY_MOONSTAND
			p.fluffyangle = p.drawangle+ANGLE_180
		elseif tonumber(arg) == 0 then
			p.fluffymoonwalking = false
			S_ChangeMusic(mapheaderinfo[gamemap].musname, true, p)
			p.normalspeed = skins["speccy"].normalspeed
			p.mo.state = S_PLAY_STND
		end
	else
		S_ChangeMusic("MNWKS"+P_RandomRange(1,6), true, p)
		p.fluffymoonwalking = true
		p.mo.state = S_NSPECCY_MOONSTAND
		p.fluffyangle = p.drawangle+ANGLE_180
	end
end)

addHook("PlayerSpawn", function(p)
	p.fluffymoonwalking = false
	p.normalspeed = skins["speccy"].normalspeed
	S_ChangeMusic(mapheaderinfo[gamemap].musname, true, p)
	p.mo.state = S_PLAY_STND
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid) then return end
	if p.mo.skin ~= "speccy" then return end
	if p.fluffymoonwalking then
		if p.speed > 1*FRACUNIT then
			p.fluffyangle = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)
			if p.mo.state ~= S_NSPECCY_MOONWALKER then
				p.mo.state = S_NSPECCY_MOONWALKER
			end
		else
			p.mo.state = S_NSPECCY_MOONSTAND
		end
		if p.fluffyangle ~= nil then
			p.drawangle = p.fluffyangle + ANGLE_180
		end
		p.normalspeed = 4*FRACUNIT
		if P_PlayerInPain(p) or (not P_IsObjectOnGround(p.mo)) or p.playerstate == PST_DEAD then
			p.fluffymoonwalking = false
			p.normalspeed = skins["speccy"].normalspeed
			S_ChangeMusic(mapheaderinfo[gamemap].musname, true, p)
			p.mo.state = S_PLAY_STND
		end
	end
end)